/**********************************************************************************************
 * This example code is provided for illustrative purposes only and provided 'AS IS' without 
 * warranty of any kind.
 * 
 * Copyright ©2014 Chrysler Group LLC.  All Rights Reserved.  All information contained herein is,
 * and remains the property of Chrysler Group LLC and its suppliers, if any.  The intellectual and
 * technical concepts contained herein are proprietary to Chrysler Group LLC and its suppliers
 * and may be covered by U.S. and Foreign Patents, patents in process, and are protected by trade
 * secret or copyright law. Dissemination of this information or reproduction of this material is
 * strictly forbidden unless prior written permission is obtained from Chrysler Group LLC.
 *
 * Chrysler, Jeep, Dodge, Ram, SRT, Mopar and the Pentastar logo are registered trademarks of
 * Chrysler Group LLC. FIAT is a registered trademark of Fiat group Marketing & Corporate
 * Communication S.p.A. used under license by Chrysler Group LLC.
 *********************************************************************************************/
package com.fca.uconnect.global;

import java.util.List;

import com.amazonaws.services.iot.client.AWSIotException;
import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotMqttClient;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectAny;
import com.fca.uconnect.global.GlobalUconnectControl.UconnectMessage;
import com.fca.uconnect.global.GlobalUconnectExtRoadSideAssist.RSADataUpload;
import com.fca.uconnect.global.GlobalUconnectExtRoadSideAssist.RSADataUpload.ErrorTellTale;
import com.fca.uconnect.global.GlobalUconnectGNSS.Location;
import com.fca.uconnect.global.GlobalUconnectVehicleInfo.TirePressure;
import com.fca.uconnect.global.GlobalUconnectVehicleInfo.VehicleInfo;
import com.fca.uconnect.global.GlobalUconnectVehicleInfo.VehicleInfo.EngineStatusEnum;
import com.google.protobuf.ByteString;
import com.google.protobuf.ExtensionRegistry;

/**
 * This example class demonstrates how to use the AWS IoT mqtt client to send a Uconnect RoadSideAsistance message with Data to the SDP .   
 * This code is only for reference and is furnished without warranty.....
 * 
 * @author FCA Global V2C API Team
 *
 */
public class TBMExampleForRSA {

	private String clientId; // The clientId is unique to the device and obtained from the client X.509 certificate CN.
	private ByteString sessionId; // The sessionId is assigned by the SDP to maintain a session independent of connection protocols.
	private int messageId; // The messageId is a sequential number incremented and assigned to each message sent from the client.
	private AWSIotMqttClient mqttClient; // The mqtt client object from the AWS IoT client library. 
	private AWSIotTopic iotTopic; // The Topic object to subscribe for inbound messages.
	private ExtensionRegistry extRegistry; // Google protocol buffers extension registry instance.
	
	List<UconnectAny> messages ;

	/**
	 * Constructor - initialize protocol buffer extension registry for parsing incoming Uconnect Messages.
	 */
	public TBMExampleForRSA() {
		extRegistry = ExtensionRegistry.newInstance();
		extRegistry.add(GlobalUconnectExtRoadSideAssist.rsaDataUpload);
	}
	
	/**
	 * This method generates a Protocol Buffer Uconnect Message given the required inputs for RoadSideAssistance Data upload
	 * @param location
	 * @param tirePressure
	 * @param errorTellTale
	 * @param statusEnum
	 * @param fuelLevel
	 * @return
	 */
	public UconnectMessage getRSADataMsg(Location location,TirePressure tirePressure,ErrorTellTale errorTellTale , EngineStatusEnum statusEnum,float fuelLevel) {
		this.messageId++;
		sessionId = ByteString.copyFrom(new byte[18]);
		VehicleInfo veh = VehicleInfo.newBuilder()
				.setVehicleLocation(location)
				.setEngineStatusEnum(statusEnum)
				.build();
		RSADataUpload rsaData = RSADataUpload.newBuilder()
				.setErrorTellTale(errorTellTale)
				.setVehicleInfo(veh)
				.setTirePressure(tirePressure)
				.build();
		UconnectMessage msg = UconnectMessage.newBuilder()
			.setTimestamp(System.currentTimeMillis())
			.setMessageId(messageId)
			.addMessages(UconnectAny.newBuilder().
			 setExtension(GlobalUconnectExtRoadSideAssist.rsaDataUpload, rsaData))
			.build();
		return msg;		
	}
	
	/**
	 * This method demonstrates connecting to the AWS IoT mqtt broker and publishing an RSADataUpload message to the RSA topic.
	 */
	public void process() {
		
		mqttClient = new AWSIotMqttClient("endpoint", clientId, "awsAccessKeyId", "awsSecretAccessKey");
		try {			
			mqttClient.connect();						
						
			iotTopic = new AWSIotTopic(clientId+"/RSA/", AWSIotQos.QOS1) {
				public void onMessage(AWSIotMessage msg) {
					// You can receive messages if SDP sends any 
				}
			};
			mqttClient.subscribe(iotTopic);
			Location carLocation = Location.newBuilder()
					.setPositionLongitude(43.9999)
					.setPositionLatitude(-84.54635343f)
					.build();
			TirePressure tirePressureMsg = TirePressure.newBuilder()
					.setFlTirePressure(35)
					.setFrTirePressure(34)
					.setRlTirePressure(36)
					.setRrTirePressure(35)
					.build();
			ErrorTellTale tellTaleMsg = ErrorTellTale.newBuilder()
					.setIsOilPressure(true)
					.build();
			EngineStatusEnum engineStatus = EngineStatusEnum.REQUESTSTART;
			UconnectMessage msg = getRSADataMsg(carLocation,tirePressureMsg,tellTaleMsg,engineStatus,20f);
			mqttClient.publish("/RSA/"+clientId, AWSIotQos.QOS1, msg.toByteArray());

		} catch (AWSIotException ex) {
			System.out.println("Caught AWS Exception "+ex);
			ex.printStackTrace();
		}  catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Example main to launch example.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		TBMExampleForRSA example = new TBMExampleForRSA();
		example.process();
	}

}
